@echo off& setlocal& set p2=phpar2& set p2a=-q -m64& set p2c=-r5 -n1
if "%~1"=="" (goto givehelp) else call :parseargs %*|| exit /b
if not %c%==u call :flatten "%p%"& call :cmd_%c% "%p%%~n0.par2"
call :unflatten "%p%"& exit /b

:cmd_c
del %1 2>nul
dir "%p%"/b/a-d/s>nul 2>nul|| (echo %~n0: No data files in "%p%"& exit /b)
%p2% c %p2a% %p2c% %1 "%p%.\*.*"
(if exist %1 del %1& ren "%p%%~n0.*.par2" "%~n0.par2")& exit /b
:cmd_r
:cmd_v
(if exist %1 (%p2% %c% %p2a% %1) else echo %~n0: No %1 file!)& exit /b

:flatten
for /d %%d in ("%~1%~2*.*") do call :flatten "%~1" "%~2%%~nxd\" "%~3%%~nxd`"
if not "%~2"=="" for %%f in ("%~1%~2*.*") do move "%%f" "%~1%~3%%~nxf">nul
exit /b

:unflatten
(for %%f in ("%~1*`*") do set t1=%%f& call :unflatsub)& exit /b
:unflatsub
(move "%t1%" "%t1:`=\%">nul 2>nul|| call :unflatsub2 "%t1:`=\%")& exit /b
:unflatsub2
md "%~dp1" 2>nul& del "%~1" 2>nul& move "%t1%" "%~1">nul& exit /b

:parseargs
rem Parse args -- errorlevel= 1 if bad. Sets vars: c {p {p2a,p2c}}
set c=& set p=%~2& set t1=:%~2
if not "%t1:~-1%"==":" if not "%t1:~-1%"=="\" set p=%p%\
if not exist "%p%*.*" echo %~n0: Path not found: %p%& exit /b 1

for %%c in (c v r u) do if /i "%~1"=="%%c" set c=%%c
if %c%x==x echo %~n0: Command unknown: %1& exit /b 1
if %c%==u exit /b 0

dir "%p%*`*"/s>nul 2>nul&& (
 echo *** %~n0: Can't have backquote in path/file& exit /b 1)
(dir "%p%"/s/ah>nul 2>nul||dir "%p%"/s/as>nul 2>nul) && (
 echo *** %~n0: Can't have hidden/system path/file& exit /b 1)

(if not "%~3"=="" set p2c=& set p2a=%~3)& exit /b 0

:givehelp
echo.& echo %~n0 ver 1.4: %p2% w/sub-directory support  paulhoule.com 9/28/15
echo.& echo Usage:  %~n0 Command {Path {Opts}}
echo   Command=      C, V, R, U -- Create, Verify, Repair, Undo
echo   Path=         Path to data -- default is current dir
echo   Opts=         Options for %p2% -- default is "%p2a% %p2c%"& echo.
echo Examples:
echo   %~n0 c . -r10  Create 10%% %~n0.par2 for current dir
echo   %~n0 r         Repair data in current directory
echo   %~n0 v d:      Verify data in d:
echo   %~n0 u         Undo aborted %~n0 (move files back to subdirs)
echo.& echo Note: par2 size for datasets under 500 meg or so are far above
echo specified percentage due to the way %p2% selects blocksize.
